;tab4:UTF-8
;	PC-6601/SR用内蔵FDD入出力ルーチン+フォーマット
;	1D/1DD 専用 切り替えは call Disk66_Change1DD で行う
;
;	di/ei アリ。uPD765Aの仕様で何usまでに処理を完了させなければならないという制限があるらしい
;	ので、特にロード中に割り込み処理をする必要のない場合は外してもOK ソース中"*1"でマーク
;
;えすび氏とMORIYA氏の解析結果に基づきます。多謝。
;個別のルーチンはcf=1でエラーを返すがLoad66/Save66はcfを拾わないので、エラー処理を厳密にする場合は修正のこと。
;
;memo.
;Disk66_DRVBusyが全ドライブreadyになるまで待つのは変？
;サイズを抑えるため Drv/Trk/Sec 範囲チェックのいくつかをコメントアウトした

;ロードのみ:490byte 全部入り:818byte
;http://community.osdev.info/index.php?(FDC)765A
;http://homepage.ntlworld.com/mark.woodmass/necfdc.htm
;765A仕様

	relaxed on

READDISK			equ	$1b67
WRITEDISK			equ	$1b6a

	IFNDEF IO_FDD66BUF0
IO_FDD66BUF0		equ	$D0				;ディスク内部バッファ$000-$0FFのアクセスポート(I/O)
IO_FDD66BUF1		equ	$D1				;ディスク内部バッファ$100-$1FFのアクセスポート(I/O)
IO_FDD66BUF2		equ	$D2				;ディスク内部バッファ$200-$2FFのアクセスポート(I/O)
IO_FDD66BUF3		equ	$D3				;ディスク内部バッファ$300-$3FFのアクセスポート(I/O)
IO_FDD66STATM		equ	$D4				;モーター状態 bit1=Drv2 bit0=Drv1 1:停止中 0:動作中 (I)
IO_FDD66CTRLM		equ	$D6				;モーター制御 bit1=Drv2 bit0=Drv1 1:停止 　0:動作 (O)
IO_FDD66ADJUST		equ	$D8				;書き込み時の調整値(?)(O) 書き込み先trkが0-4の時1 それ以外0
IO_FDD66SECLEN		equ	$DA				;(15-転送セクタ数) ディスク内部バッファ及びuPD765の転送サイズ(O)
IO_FDD66STAT765		equ	$DC				;uPD765A ステータス(I)
IO_FDD66DATA765		equ	$DD				;uPD765A データレジスタ(I/O)
IO_FDD66VFO			equ	$DE				;読み書き時のVFO調整値(O)（エラー発生時に調整してリトライ）
	ENDIF

;DISK66_NOSAVE		equ	1				;SAVEを使うときはコメントアウト

FDD66RETRYMAX		equ	10				;リトライ回数 1～16

;エントリ

	org			$00c0

Disk66_Entry:
	jp			Disk66_Init				;+0
	jp			Disk66_Load				;+3
		IFDEF DISK66_NOSAVE
	jp			$						;+6
	jp			$						;+9
		ELSE
	jp			Disk66_Save				;+6
	jp			Disk66_Format			;+9
		ENDIF
	jp			Disk66_Change1DD		;+12


	org			$00cf

ERRDISP_R:		
	db			$00
ERRDISP_W:		
	db			$00

ERRDISP_SUB:
	ld			a,$ed			; 読み出し：外部RAM/内部RAM=FF-C0/BF-80
	out			($f1),a
	ld			a,$95			; 書き込み：外部RAM/内部RAM/内部RAM/内部RAM=FF-C0/BF-80/7F-40/3F-00
	out			($f2),a

	call		$1b55			; キーバッファクリア
	ld			hl,$02ea		; エラーメッセージ
	call		$1f2f			; 表示画面クリア＋画面表示
	call		$1b40			; キー入力待ち
	pop			hl				; キーデータを捨てる
	ld			hl,($02ea)
	call		$1f2f			; 表示画面クリア＋画面表示

	ld			a,(ERRDISP_R) 
	out			($f1),a
	ld			a,(ERRDISP_W)
	out			($f2),a

	ret


	org			$0100
	jp			READDISK

Disk66_SecCnt:		db	0				;ロードすべきセクタ数(1-255)
Disk66_RetryCnt:	db	0				;リトライカウンタ
Disk66_BufCnt:		db	0				;バッファをいくつ使ったか(1-4)
Disk66_Status:		ds	7				;ST0,ST1,ST2,C,H,R,N 

Disk66_Init:							;d に初期化するドライブ番号(0-3)を入れておくこと
;	ld			a,($FFFF)				;SR時 1 が書き込まれている("SYS"or"RXR")
;	dec			a
;	jr			nz,.skip
	ld			a,$00					;66SR用にパッチをあてる(NOP)
	ld			(Disk66_Seek.patchsr),a
	ld			(Disk66_Seek.patchsr+1),a
.1dd:
;	ld			a,80					;66SR用にパッチをあてる
;	ld			(Disk66_SeekSub.patchsr+1),a
		IFNDEF DISK66_NOSAVE
	ld			a,60
	ld			(Disk66_WriteSector.patchsr+1),a
;	ld			(Disk66_Format.patchsr+1),a
		ENDIF
.skip:
	ld			a,$F3
	out			($B1),a					;内蔵ドライブ設定
;	ld			d,0						;iplで設定
	ld			e,$05					;d=drv e=trk
	call		Disk66_Recalib
	call		Disk66_Recalib
	call		Disk66_Seek				;trk=5 にシーク
	call		Disk66_Recalib
	ld			bc,"ni"					;x1のみ
	ret

Disk66_Change1DD:
	ld			a,$18					;トラック2倍->1倍仕様に戻す
	ld			(Disk66_Seek.patchsr),a
	ld			a,Disk66_SeekSub-Disk66_Seek.patchsr-2
	ld			(Disk66_Seek.patchsr+1),a
		IFNDEF DISK66_NOSAVE
	ld			a,80
;	ld			(Disk66_Format.1dd),a
		ENDIF
	jr			Disk66_Init.1dd			;トラック番号は79まで


; HL=ロード/セーブ開始アドレス
; B= セクタ数
; C= ドライブ番号
; D= トラック番号
; E= セクタ番号
;エントリレジスタは60外付けDISKルーチンに合わせる

Disk66_Load:
	ld			a,$F3
	out			($B1),a					;内蔵ドライブ設定
	ld			a,b
	ld			(Disk66_SecCnt),a		;読み込み総セクタ数

	ld			a,d						;ここでレジスタ変換
	ld			d,c						;d=drv
	ld			c,e						;c=sec
	ld			e,a						;e=trk

.loop:
	ld			a,(Disk66_SecCnt)
	ld			b,a
	cp			5
	jr			c,.skip1				;読み込みセクタ数5以上は4にする
	ld			b,4
.skip1:
	ld			a,17
	sub			c						;a=そのトラックの残りセクタ
	cp			b						;b=読む込みセクタ数
	jr			nc,.skip2
	ld			b,a
.skip2:
	push		bc
	push		de

	push		hl
	call		Disk66_ReadSector		;d(drv)e(trk)c(sec)からb(1-)セクタ分読む
	pop			hl

	call		nc,Disk66_Buf2RAM		;ディスク内部バッファからMainRAM(hl)へ転送
	pop			de
	pop			bc
	ret			c						;ReadSectorのエラーで戻る。Buf2RAMは常にcf=0

	ld			a,c
	add			a,b
	ld			c,a						;sec+=読み込んだセクタ数
	cp			17
	jr			c,.next
	ld			c,1						;sec=1
	inc			e						;trk++
.next:
	ld			a,(Disk66_SecCnt)
	sub			b
	ld			(Disk66_SecCnt),a		;読み込むべきセクタ数-=読み込んだセクタ数
	jr			nz,.loop
.exit:
	ld			a,d
	ld			d,e
	ld			e,c
	ld			c,a						;60外付けディスクルーチンに合わせてレジスタ再変換

	ld			a,$F7					;FDType=外部,DMA Read,DMA Off
	out			($B1),a
	or			a						;cf=0 正常終了
	ret


Disk66_MotorON:
	inc			d						;d=1(drv.0) d=2(drv.1)
	in			a,(IO_FDD66STATM)
	cpl
	ld			b,a						;b=モーター状態xxxxxxdd  1=動作中 0=停止中 bit1/0=drv1/0
	or			d						;↑eにする場合はpush deが必要
	cpl
	out			(IO_FDD66CTRLM),a		;モーターのスピンアップを指示する
	ld			a,d
	dec			d
	and			b
	ret			nz						;モーターの状態が停止→開始ならウェイトを挟む

.wait:
	push		bc
	ld			bc,0
.loop:
	push		bc
	pop			bc
	dec			c
	jr			nz,.loop
	djnz		.loop
	pop			bc
	ret


	org			$01c5
	jp			WRITEDISK


; データはFDD内部バッファにストアされる
; B= セクタ数(1～4)
; E= トラック番号
; C= セクタ番号
; D= ドライブ番号
Disk66_ReadSector:
	ld			hl,Disk66_RetryCnt
	ld			(hl),FDD66RETRYMAX		;リトライ回数
	inc			hl
	ld			(hl),b					;セクタ数保存 後でDriveMemからMainRAMに転送する時に必要
	ld			a,$08
	out			(IO_FDD66VFO),a			;VFO初期値 8

.readsec:
	push		bc
	call		Disk66_MotorON
	call		Disk66_Seek
	pop			bc
	ret			c

;	ld			a,c						;secは1-16まで
;	cp			17
;	ccf
;	ret			c						;sec=0が通過してしまうので厳密でない。

	ld			a,15
	sub			b						;b=1～4	最大4セクタ読む
	out			(IO_FDD66SECLEN),a		;15-seccnt

	call		Disk66_FDCBusy
	call		Disk66_DRVBusy

	push		bc
	ld			b,$46					;READ DATA ("4"はMT MF SK 0)
	call		Disk66_Write765			;[CMD:06] [HD-US] [C] [H] [R] [N] [EOT] [GPL] [DTL]

;	di									;*1
	call		Disk66_Write765Param
	ld			a,$F2					;FDType=内蔵,DMA Read,DMA On
	out			($B1),a
;	ei									;*1
	call		Disk66_WaitFDDINT
	ld			a,$F3					;FDType=内蔵,DMA Read,DMA Off
	out			($B1),a
	call		Disk66_Result
	pop			bc
	ret			nc						;エラーがなければ戻る

	ld			hl,Disk66_RetryCnt		;リトライ回数
	ld			a,(hl)
	dec			(hl)
	jr			z,.err

	ld			hl,Disk66_VFOTABLE		;VFOに書き込む値のテーブル
	add			a,l
	ld			l,a
	adc			a,h
	sub			l
	ld			h,a
	ld			a,(hl)
	out			(IO_FDD66VFO),a			;エラー発生時に調整してリトライ
	jr			.readsec
.err:
	call		Disk66_RECALIB
	scf
	ret									;リトライしてもダメだったのでエラーを返す

Disk66_VFOTABLE:						;16byteあるけど#2-10までしか使ってない?
	db			$08,$08,$0B,$05,$09,$07,$0C,$04,$0A,$06,$08,$08,$08,$08,$08,$08

Disk66_Write765Param:
	ld			b,d						;ドライブ番号
	call		Disk66_Write765
	ld			b,e						;C トラック番号
	call		Disk66_Write765
	ld			b,0						;H ヘッド番号 0=表
	call		Disk66_Write765
	ld			b,c						;R セクタ番号(1-16)
	call		Disk66_Write765
	ld			b,1						;N セクタ長 1=256byte
	call		Disk66_Write765
	ld			b,$10					;EOT (最終セクタ)
	call		Disk66_Write765
	ld			b,$14					;GPL (GAP長)
	call		Disk66_Write765
	ld			b,$FF					;DTL (データ長)
	jp			Disk66_Write765


Disk66_Read765:
	in			a,(IO_FDD66STAT765)
	cpl
	and			$C0						;bit7=Request for Master bit6=DataI/O
	jr			nz,Disk66_Read765
	in			a,(IO_FDD66DATA765)
	ret

Disk66_Write765:						;b=書き込むデータ
	in			a,(IO_FDD66STAT765)
	xor			$80
	and			$C0
	jr			nz,Disk66_Write765
	ld			a,b
	out			(IO_FDD66DATA765),a
	ret


	org			$0273					; フォーマット
	rst			$38


Disk66_Seek:
.patchsr:
	jr			Disk66_SeekSub			;非SR はそのままコールする

	push		de
	sla			e						;SR は SEEKの時にトラック番号を倍にする
	call		Disk66_SeekSub
	pop			de						;倍にしたトラック番号を戻す
	ret

Disk66_SeekSub:
;	ld			a,d						;drvは0-3まで
;	cp			4
;	ccf
;	ret			c

;	ld			a,e						;trkは0-39まで（SR は0-79まで）
;.patchsr:
;	cp			40
;	ccf
;	ret			c

	call		Disk66_FDCBusy

	ld			b,$0F					;SEEK
	call		Disk66_Write765			;[cmd:0F] [HD-US] [NCN]
	ld			b,d						;drv
	call		Disk66_Write765
	ld			b,e						;trk
	call		Disk66_Write765

Disk66_CMDResult:						;seek/recalibの結果エラーかどうかFDCに尋ねる
	call		Disk66_WAITFDDINT
	call		Disk66_FDCBUSY

	ld			b,$08					;SENSE INT STATUS
	call		Disk66_Write765			;[cmd:08]	ST0とPCNが返る

	call		Disk66_Read765			;ST0
	and			%11011111				;bit5=Seek End
	xor			d						;drv
	ld			c,a

	call		Disk66_Read765			;PCN 現trk番号
	xor			e						;指定したトラック番号から外れていたらエラー
	or			c						;c=0以外ならエラー
	ret			z						;cf=0 正常終了
	scf									;cf=1 エラー
	ret

Disk66_Recalib:
;	ld			a,d						;drvは0-3まで
;	cp			4
;	ccf
;	ret			c

	call		Disk66_FDCBUSY

	ld			b,$07					;RECALIBRATE
	call		Disk66_Write765			;[cmd:07] [HD-US]
	ld			b,d						;drv
	call		Disk66_Write765

	push		de
	ld			e,0						;trk
	call		Disk66_CMDResult
	pop			de
	ret

Disk66_Buf2RAM:
	ld			a,(Disk66_BufCnt)
	ld			e,a
	add			a,h
	ld			h,a						;hl+256*sectors（セクタ数は1～4 ディスク内部バッファが256byte*4なので）
	push		hl
	dec			hl						;アドレスの後ろから埋めていく

	ld			a,IO_FDD66BUF0 -1
	add			a,e
	ld			c,a						;$D0～$D3
.loop:
	ld			b,$FF 					;in/out系命令のA8-A15がディスク内バッファの下位アドレスになる.
	indr								;indr/indにおいては b が 00xx～03xxに相当する
	ind									;bはデクリメントなので(hl)にも後ろから埋めていかなければならない
	dec			c
	dec			e
	jr			nz,.loop
	pop			hl						;戻りhlアドレスは更新済み.
	or			a
	ret									;cf=0

;--------------------------------------------------------------------------------------------------

	org			$02ea					; 使えるエリアがここまで
	db			$ff


	org			$03c0
	phase		$18e9

;--------------------------------------------------------------------------------------------------

; Result Phase 
; ST0,ST1,ST2,C,H,R,N が返る
Disk66_Result:
	call		Disk66_Read765			;Result Status ST0
	ld			hl,Disk66_Status		;ステータス保存
	ld			(hl),a
	inc			hl
	and			%11011111				;bit5=Seek End bit0-1=Unit Select
	xor			d						;xor drv 
	ld			b,a						;b=0以外はエラーあり

	call		Disk66_Read765			;Result Status ST1
	ld			(hl),a
	inc			hl
	or			b
	ld			b,a						;b=0以外はエラーあり

	call		Disk66_Read765			;Result Status ST2
	ld			(hl),a
	inc			hl
	and			%01110011				;bit7=常に1 bit3=Scan Equal Hit
	or			b						;a=0以外はエラーあり

	push		af
	ld			b,4
.loop:
	call		Disk66_Read765			;CHRN
	ld			(hl),a
	inc			hl
	djnz		.loop
	pop			af
	ret			z						;エラーなしcf=0
	scf									;エラーありcf=1
	ret


Disk66_FDCBusy:
	in			a,(IO_FDD66STAT765)
	bit			4,a
	jr			nz,Disk66_FDCBusy		;bit4=FDC busy
	ret

Disk66_DrvBusy:
	in			a,(IO_FDD66STAT765)
	and			$0F						;bit0-3=drv0-3のbusy
	jr			nz,Disk66_DrvBusy
	ret

Disk66_WaitFDDINT:
	in			a,(IO_FDD66STAT765)		;これ要るのかな?
	ld			a,$FE
	out			($B3),a					;Port$B2.0 方向=入力
	in			a,($B2)
	rra									;$B2.0=1 FDD割り込みが来るまで待つ
	jr			nc,Disk66_WaitFDDINT
	ret


;--------------------------------------------------------------------------------------------------
;以下、セーブルーチン　不要なら削除のこと.
	IFNDEF	DISK66_NOSAVE
Disk66_Save:
	ld			a,$F3
	out			($B1),a					;内蔵ドライブ設定
	ld			a,b
	ld			(Disk66_SecCnt),a		;書き込み総セクタ数

	ld			a,d						;ここでレジスタ変換
	ld			d,c						;d=drv
	ld			c,e						;c=sec
	ld			e,a						;e=trk

.loop:
	ld			a,(Disk66_SecCnt)
	ld			b,a
	cp			5
	jr			c,.skip1				;読み込みセクタ数5以上は4にする
	ld			b,4
.skip1:
	ld			a,17
	sub			c						;a=そのトラックの残りセクタ
	cp			b						;b=読む込みセクタ数
	jr			nc,.skip2
	ld			b,a
.skip2:
	push		bc
	push		de
	call		Disk66_RAM2Buf			;MainRAM(hl)からディスク内部バッファ)へ転送
	pop			de
	pop			bc

	push		hl
	call		Disk66_WriteSector		;d(drv)e(trk)c(sec)へb(1-)セクタ分書く
	pop			hl
	ret			c

	ld			a,c
	add			a,b
	ld			c,a						;sec+=書き込んだセクタ数
	cp			17
	jr			c,.next
	ld			c,1						;sec=1
	inc			e						;trk++
.next:
	ld			a,(Disk66_SecCnt)
	sub			b
	ld			(Disk66_SecCnt),a		;読み込むべきセクタ数-=読み込んだセクタ数
	jr			nz,.loop
.exit:
	ld			a,d
	ld			d,e
	ld			e,c
	ld			c,a						;60外付けディスクルーチンに合わせてレジスタ再変換

	ld			a,$F7					;FDType=外部,DMA Read,DMA Off
	out			($B1),a
	or			a						;cf=0正常終了
	ret


Disk66_WriteSector:
	ld			hl,Disk66_RetryCnt
	ld			(hl),FDD66RETRYMAX		;リトライ回数
	ld			a,$08
	out			(IO_FDD66VFO),a			;VFO初期値 8

.writesec:
	push		bc
	call		Disk66_MotorON
	call		Disk66_Seek
	pop			bc
	ret			c

;	ld			a,c						;secは1-16まで
;	cp			17
;	ccf
;	ret			c						;sec=0が通過してしまうので厳密でない。

	ld			a,15
	sub			b						;b=1～4	最大4セクタ読む
	out			(IO_FDD66SECLEN),a		;15-seccnt

	ld			a,e
.patchsr:
	cp			20						;↓66SRではトラック60以上で0を書き込む
	ld			a,0						;トラック20以上なら0 20未満なら1
	jr			nc,.adjust
	inc			a
.adjust:
	out			(IO_FDD66ADJUST),a

	call		Disk66_FDCBusy
	call		Disk66_DRVBusy

	push		bc
	ld			b,$45					;WRITE DATA ("4"はMT MF SK 0)
	call		Disk66_Write765			;[CMD:05] [HD-US] [C] [H] [R] [N] [EOT] [GPL] [DTL]

;	di									;*1
	call		Disk66_Write765Param
	ld			a,$F0					;FDType=内蔵,DMA Write,DMA On
	out			($B1),a
;	ei									;*1
	call		Disk66_WaitFDDINT
	ld			a,$F3					;FDType=内蔵,DMA Read,DMA Off
	out			($B1),a
	call		Disk66_Result
	pop			bc
	ret			nc						;エラーがなければ戻る

	ld			hl,Disk66_RetryCnt		;リトライ回数
	ld			a,(hl)
	dec			(hl)
	jr			z,.err

	ld			hl,Disk66_VFOTABLE		;VFOに書き込む値のテーブル
	add			a,l
	ld			l,a
	adc			a,h
	sub			l
	ld			h,a
	ld			a,(hl)
	out			(IO_FDD66VFO),a			;エラー発生時に調整してリトライ
	jr			.writesec
.err:
	call		Disk66_RECALIB
	scf
	ret									;リトライしてもダメだったのでエラーを返す


Disk66_RAM2Buf:
	ld			a,b
	ld			(Disk66_BufCnt),a		;一応保存
	ld			e,a
	add			a,h
	ld			h,a						;hl+256*sectors（セクタ数は1～4 ディスク内部バッファが256byte*4なので）
	push		hl
	dec			hl						;アドレスの後ろからバッファに転送していく.最大で $03FF -> $0000

.loop:
	ld			a,IO_FDD66BUF0 -1
	add			a,e
	ld			c,a						;$D0～$D3

	ld			b,0 					;in/out系命令のA8-A15がディスク内バッファの下位アドレスになる.
	otdr								;otdrにおいては b が 00xx～03xxに相当する
	dec			e						;注:otdr命令はbを先にデクリメントする b-- (c)<-(hl) hl--
	jr			nz,.loop
	pop			hl						;戻りhlアドレスは更新済み
	ret


;--------------------------------------------------------------------------------------------------
;以下、フォーマットルーチン　不要なら削除のこと.
;d=ドライブ番号(0/1)を入れてcall
Disk66_Format:

	ENDIF

	dephase

	org			$04bf
	db			$ff

